unit pr_PageParams;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Pr_Utils,

  pr_Common, pr_Classes, pr_MultiLang;

type
  TprPageParamsForm = class(TprForm)
    PC: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    bOK: TButton;
    bCancel: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    iPagePortrait: TImage;
    iPageLandscape: TImage;
    RBPortrait: TRadioButton;
    RBLandscape: TRadioButton;
    EDPaperSize: TComboBox;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EDPageWidth: TEdit;
    EDPageHeight: TEdit;
    UDPageWidth: TUpDown;
    UDPageHeight: TUpDown;
    CBOther: TCheckBox;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    EDLeft: TEdit;
    EDTop: TEdit;
    EDRight: TEdit;
    EDBottom: TEdit;
    UDLeft: TUpDown;
    UDTop: TUpDown;
    UDRight: TUpDown;
    UDBottom: TUpDown;
    Label8: TLabel;
    Label9: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    EDTopMin: TEdit;
    EDBottomMin: TEdit;
    EDLeftMin: TEdit;
    EDRightMin: TEdit;
    prMLRes1: TprMLRes;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RBPortraitClick(Sender: TObject);
    procedure bOKClick(Sender: TObject);
    procedure CBOtherClick(Sender: TObject);
  private
    { Private declarations }
    Page : TprPage;
  public
    { Public declarations }
    function EditOptions(_Page : TprPage) : boolean;
  end;

implementation

uses pr_Strings;

{$R *.DFM}

procedure TprPageParamsForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Action:=caFree;
end;

function TprPageParamsForm.EditOptions;
begin
Page:=_Page;

RBPortrait.Checked   :=Page.Orientation=poPortrait;
RBLandscape.Checked  :=Page.Orientation=poLandscape;
EDPaperSize.Items.Assign(TprReport(Page.Report).prPrinter.PaperNames);
EDPaperSize.ItemIndex:=TprReport(Page.Report).prPrinter.GetPaperSizeArrayPos(Page.PaperSize);
CBOther.Checked      :=EDPaperSize.ItemIndex=-1;
UDPageWidth.Position :=Page.Width;
UDPageHeight.Position:=Page.Height;
UDLeft.Position      :=Page.lMargin;
UDTop.Position       :=Page.tMargin;
UDRight.Position     :=Page.rMargin;
UDBottom.Position    :=Page.bMargin;
EDLeftMin.Text       :=IntToStr(Page.pInfo.mmlMargin);
EDTopMin.Text        :=IntToStr(Page.pInfo.mmtMargin);
EDRightMin.Text      :=IntToStr(Page.pInfo.mmrMargin);
EDBottomMin.Text     :=IntToStr(Page.pInfo.mmbMargin);

RBPortraitClick(nil);
CBOtherClick(nil);

Result:=ShowModal=mrOk;
end;

procedure TprPageParamsForm.RBPortraitClick(Sender: TObject);
begin
iPagePortrait.Visible :=RBPortrait.Checked;
iPageLandscape.Visible:=RBLandscape.Checked;
end;

procedure TprPageParamsForm.CBOtherClick(Sender: TObject);
begin
EDPageWidth.Enabled :=CBOther.Checked;
EDPageHeight.Enabled:=CBOther.Checked;
UDPageWidth.Enabled :=CBOther.Checked;
UDPageHeight.Enabled:=CBOther.Checked;
EDPaperSize.Enabled :=not CBOther.Checked;
end;

procedure TprPageParamsForm.bOKClick(Sender: TObject);
var
  pgOrientation : TprPrinterOrientation;
  pgSize,pgWidth,pgHeight : integer;
begin
if (UDLeft.Position<Page.pInfo.mmlMargin) or
   (UDRight.Position<Page.pInfo.mmrMargin) or
   (UDTop.Position<Page.pInfo.mmtMargin) or
   (UDBottom.Position<Page.pInfo.mmbMargin) then
  begin
    if MBox(prLoadStr(sPageMarginsWarning),prLoadStr(sAttention),MB_YESNO+MB_ICONEXCLAMATION)=IDNO then
      exit;
  end;

pgOrientation:=poPortrait;
if RBLandscape.Checked then
  pgOrientation:=poLandscape;

if CBOther.Checked then
  begin
    pgSize  :=-1;
    pgWidth :=UDPageWidth.Position;
    pgHeight:=UDPageHeight.Position;
  end
else
  begin
    pgSize  :=TprReport(Page.Report).prPrinter.PaperSizes[EDPaperSize.ItemIndex];
    pgWidth :=UDPageWidth.Position;
    pgHeight:=UDPageHeight.Position;
  end;

Page.lMargin   :=UDLeft.Position;
Page.rMargin   :=UDRight.Position;
Page.tMargin   :=UDTop.Position;
Page.bMargin   :=UDBottom.Position;

Page.ChangePaper(pgSize,pgWidth,pgHeight,pgOrientation);
ModalResult:=mrOk;
end;

end.
