unit pr_Progress;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, pr_MultiLang;


type
  ////////////////////////////
  //
  // Exception
  //
  ////////////////////////////
  EActionCanceled = class(Exception)
  end;

  TprProgressForm = class(TForm)
    ProgressBar1: TProgressBar;
    STDesc: TStaticText;
    bCancel: TButton;
    prMLRes1: TprMLRes;
    procedure bCancelClick(Sender: TObject);
  private
    { Private declarations }
    OnCancel : TNotifyEvent;
  public
    { Public declarations }
    fCancelPrepare : boolean;

    procedure InitPF(_Caption : string = ''; _Max : integer = 0; _OnCancel : TNotifyEvent = nil);
    procedure UpdatePF(_Desc : string = ''; _Step : integer = 0);
  end;

implementation

uses pr_Strings;

{$R *.DFM}

procedure TprProgressForm.InitPF;
begin
OnCancel:=_OnCancel;

if _Caption='' then
  Caption:=prLoadStr(sDefaultProgressFormCaption)
else
  Caption:=_Caption;

if _Max>0 then
  with ProgressBar1 do
    begin
      Min     :=1;
      Max     :=_Max;
      Position:=1;
    end
else
  ProgressBar1.Visible:=false;

STDesc.Caption :='';
//bCancel.Enabled:=Assigned(OnCancel);

Show;
Update;
end;

procedure TprProgressForm.UpdatePF;
begin
STDesc.Caption:=_Desc;
if _Step=0 then
  ProgressBar1.Position:=ProgressBar1.Position+1
else
  ProgressBar1.Position:=ProgressBar1.Position+_Step;
Application.ProcessMessages;
if fCancelPrepare then
  raise EActionCanceled.Create(prLoadStr(sActionCanceled));
end;

procedure TprProgressForm.bCancelClick(Sender: TObject);
begin
fCancelPrepare:=true;
if Assigned(OnCancel) then
  OnCancel(Self);
end;

end.
